package ru.ifmo.lift;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;

import com.evelopers.unimod.core.stateworks.Event;
import com.evelopers.unimod.runtime.EventManager;
import com.evelopers.unimod.runtime.context.StateMachineContextImpl;

/**
 * 
 * Form that will be shown when lift is broken.
 *
 */
public class BreakageForm extends JFrame {
	private static final long serialVersionUID = 0;

	private static final int WIDTH = 400;
	private static final int HEIGHT = 80;
	
	JLabel message;
	JButton button;
	 
	EventManager eventManager;
	
	/**
	 * Constructor.
	 * @param eM Event manager
	 */
	BreakageForm( EventManager eM )
	{
		super( "" );
		
		eventManager = eM;
		
		int posX = MainForm.POS_X + MainForm.WIDTH / 2 - WIDTH / 2;
		int posY = MainForm.POS_Y + MainForm.HEIGHT / 2 - HEIGHT / 2;
		this.setLocation( posX, posY );
		this.setSize( WIDTH, HEIGHT );
		this.setResizable( false );
		this.setDefaultCloseOperation( JFrame.DO_NOTHING_ON_CLOSE );
		
		this.getContentPane().setLayout( new BorderLayout() );
		
		message = new JLabel( ",   . ?" );
		message.setHorizontalAlignment( JLabel.CENTER );
		this.getContentPane().add( message, BorderLayout.CENTER );
		
		button = new JButton( "" );
		button.addActionListener( new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				BreakageForm.this.setVisible( false );
				Event e = new Event( LiftEventProvider.seHasBeenRepaired );
				BreakageForm.this.eventManager.handle( e, StateMachineContextImpl.create() );
				BreakageForm.this.dispose();
			}
		} );
		this.getContentPane().add( button, BorderLayout.EAST ); 
	}
}
