package ru.ifmo.lift;

import com.evelopers.common.exception.CommonException;

import com.evelopers.unimod.runtime.*;
import com.evelopers.unimod.runtime.context.*;
import com.evelopers.unimod.core.stateworks.*;

/**
 * 
 * Event provider class. 
 *
 */
public class LiftEventProvider implements EventProvider {
	/**
	 * @unimod.event.descr  "Exit"  .
	 */
	public static final String seExit = "Exit";
	
	/**
	 * @unimod.event.descr   .
	 */
	public static final String seNewTaskAdded = "NewTaskAdded";
	
	/**
	 * @unimod.event.descr    .
	 */
	public static final String seGoUp = "GoUp";

	/**
	 * @unimod.event.descr    .
	 */
	public static final String seGoDown = "GoDown";
	
	/**
	 * @unimod.event.descr   .
	 */
	public static final String seQueueIsEmpty = "QueueIsEmpty";
	
	/**
	 * @unimod.event.descr  .
	 */
	public static final String seHasBroken = "HasBroken";
	
	/**
	 * @unimod.event.descr   .
	 */
	public static final String seHasBeenRepaired = "HasBeenRepaired";
	
	/**
	 * @unimod.event.descr    .
	 */
	public static final String seOpenTheDoors = "OpenTheDoors";
	
	/**
	 * @unimod.event.descr    .
	 */
	public static final String seCloseTheDoors = "CloseTheDoors";
		
	/**
	 * Initializes application.
	 */
	public void init(ModelEngine engine) throws CommonException 
	{
		EventManager eventManager = engine.getEventManager(); 
		
		Lift lift = (Lift)engine.getControlledObjectsManager().getControlledObject( "oLift" );
		lift.setEventManager( eventManager );
		MainForm form = (MainForm)engine.getControlledObjectsManager().getControlledObject( "oForm" );
		form.setEventManager( eventManager );
		form.setLift( lift );
		lift.setForm( form );
		
		form.setVisible( true );
		
		eventManager.handle( new Event("Start"), StateMachineContextImpl.create() );
	}

	/**
	 * This calls after application finish.
	 */
	public void dispose() 
	{
	}
}
