/**
  * This file was generated from model [Model1] on [Fri Oct 13 20:36:21 MSD 2006].
  * Do not change content of this file.
  */
package ru.ifmo.lift;

import java.io.IOException;
import java.util.*;

import org.apache.commons.lang.BooleanUtils;
import org.apache.commons.lang.math.NumberUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.evelopers.common.exception.*;
import com.evelopers.unimod.core.stateworks.*;
import com.evelopers.unimod.debug.app.AppDebugger;
import com.evelopers.unimod.debug.protocol.JavaSpecificMessageCoder;
import com.evelopers.unimod.runtime.*;
import com.evelopers.unimod.runtime.context.*;
import com.evelopers.unimod.runtime.logger.SimpleLogger;


public class Model1EventProcessor extends AbstractEventProcessor {

	private ModelStructure modelStructure;

				private static final int liftAutomat = 1;
	
	private int decodeStateMachine(String sm) {
					
		if ("liftAutomat".equals(sm)) {
			return liftAutomat;
			}

		return -1;
	}
		
			private liftAutomatEventProcessor _liftAutomat;
		
	public Model1EventProcessor() {
		modelStructure = new Model1ModelStructure();

					_liftAutomat = new liftAutomatEventProcessor();
			}

		    public static void run(int debuggerPort, boolean debuggerSuspend) throws 
						            InterruptedException, EventProcessorException, CommonException, 
        			    IOException {

        		/* Create runtime engine */
        		ModelEngine engine = createModelEngine(true);

		        /* Setup logger */
		        final Log log = LogFactory.getLog(Model1EventProcessor.class);
        		engine.getEventProcessor().addEventProcessorListener(new SimpleLogger(log));

        		/* Setup exception handler */
        		engine.getEventProcessor().addExceptionHandler(new ExceptionHandler() {
		            public void handleException(StateMachineContext context, SystemException e) {
                				log.fatal(e.getChainedMessage(), e.getRootException());
		            }
		        });

        		if (debuggerPort > 0) {
            			AppDebugger d = new AppDebugger(
            					        debuggerPort, debuggerSuspend,
                    					new JavaSpecificMessageCoder(), engine);
                    			d.start();
            		}
            		engine.start();
        	}

    	public static void main(String[] args) throws Exception {
		        int debuggerPort = NumberUtils.stringToInt(System.getProperty("debugger.port"), -1);
        		boolean debuggerSuspend = BooleanUtils.toBoolean(System.getProperty("debugger.suspend"));
        		Model1EventProcessor.run(debuggerPort, debuggerSuspend);
    	}

    	public static ModelEngine createModelEngine(boolean useEventQueue) throws CommonException {
        	ObjectsManager objectsManager = new ObjectsManager();
        	return ModelEngine.createStandAlone(
        		        useEventQueue ? (EventManager) new QueuedHandler() : (EventManager) new StrictHandler(), 
        		        new Model1EventProcessor(),
                objectsManager.getControlledObjectsManager(),
                objectsManager.getEventProvidersManager());
	    }

	    public static class ObjectsManager {
	        private ru.ifmo.lift.MainForm oForm = null;
	        private ru.ifmo.lift.Lift oLift = null;
	        private ru.ifmo.lift.LiftEventProvider liftEventProvider = null;
	    
	        private ControlledObjectsManager controlledObjectsManager = new ControlledObjectsManagerImpl();
	        private EventProvidersManager eventProvidersManager = new EventProvidersManagerImpl();

	        public ControlledObjectsManager getControlledObjectsManager() {
	            return controlledObjectsManager;
	        }

	        public EventProvidersManager getEventProvidersManager() {
	            return eventProvidersManager;
	        }

	        private class ControlledObjectsManagerImpl implements ControlledObjectsManager {
	            public void init(ModelEngine engine) throws CommonException {}

	            public void dispose() {}

	            public ControlledObject getControlledObject(String coName) {
                if (StringUtils.equals(coName, "oForm")) {
                		    if (oForm == null) {
                		        oForm = new ru.ifmo.lift.MainForm();
                		    }
                		    return oForm;
                }
                if (StringUtils.equals(coName, "oLift")) {
                		    if (oLift == null) {
                		        oLift = new ru.ifmo.lift.Lift();
                		    }
                		    return oLift;
                }
	                throw new IllegalArgumentException("Controlled object with name [" + coName + "] wasn't found");
	            }
	        }

	        private class EventProvidersManagerImpl implements EventProvidersManager {
	            private List nonameEventProviders = new ArrayList();

	            public void init(ModelEngine engine) throws CommonException {
	                EventProvider ep;
	                ep = getEventProvider("liftEventProvider");
                ep.init(engine);
	            }

	            public void dispose() {
	                	EventProvider ep;
		                ep = getEventProvider("liftEventProvider");
                ep.dispose();
                for (Iterator i = nonameEventProviders.iterator(); i.hasNext();) {
                    ep = (EventProvider) i.next();
                    ep.dispose();
                }
            }

	            public EventProvider getEventProvider(String epName) {
	                if (StringUtils.equals(epName, "liftEventProvider")) {
                		    if (liftEventProvider == null) {
                		        liftEventProvider = new ru.ifmo.lift.LiftEventProvider();
                		    }
                		    return liftEventProvider;
                }
                throw new IllegalArgumentException("Event provider with name [" + epName + "] wasn't found");
	            }
	        }
    	}
	
    public ModelStructure getModelStructure() {
		return modelStructure;
	}	
	
    public void setControlledObjectsMap(ControlledObjectsMap controlledObjectsMap) {
        super.setControlledObjectsMap(controlledObjectsMap);
		
					_liftAutomat.init(controlledObjectsMap);
		    }

	protected StateMachineConfig process(
            Event event, StateMachineContext context,
            StateMachinePath path, StateMachineConfig config) throws SystemException {

		// get state machine from path
		int sm = decodeStateMachine(path.getStateMachine());
		
		try {
		switch (sm) {
					case liftAutomat:
				return _liftAutomat.process(event, context, path, config);
					default:
				throw new EventProcessorException("Unknown state machine [" + path.getStateMachine() + "]");
		}
		} catch (Exception e) {
			if (e instanceof SystemException) {
				throw (SystemException)e;
			} else {
				throw new SystemException(e);
			}
		}
	}

    protected StateMachineConfig transiteToStableState(
            StateMachineContext context,
            StateMachinePath path, StateMachineConfig config) throws SystemException {

		// get state machine from path
		int sm = decodeStateMachine(path.getStateMachine());

		try {
		switch (sm) {
					case liftAutomat:
				return _liftAutomat.transiteToStableState(context, path, config);
					default:
				throw new EventProcessorException("Unknown state machine [" + path.getStateMachine() + "]");
		}
		} catch (Exception e) {
			if (e instanceof SystemException) {
				throw (SystemException)e;
			} else {
				throw new SystemException(e);
			}
		}
	}	

	
	
private class Model1ModelStructure implements ModelStructure {
	    private Map configManagers = new HashMap();

    private Model1ModelStructure() {
		        configManagers.put("liftAutomat", new com.evelopers.unimod.runtime.config.DistinguishConfigManager());
		    }

	    public StateMachinePath getRootPath() 
	            throws EventProcessorException {
	        	return new StateMachinePath("liftAutomat");				
	    }

	    public StateMachineConfigManager getConfigManager(String stateMachine) 
	            throws EventProcessorException {
		        return (StateMachineConfigManager)configManagers.get(stateMachine);
	    }

	    public StateMachineConfig getTopConfig(String stateMachine) 
	            throws EventProcessorException {
        		int sm = decodeStateMachine(stateMachine);
		
		        switch (sm) {
					            case liftAutomat:
                				return new StateMachineConfig("Top");
					            default:
                				throw new EventProcessorException("Unknown state machine [" + stateMachine + "]");
		        }
	    }

    	public boolean isFinal(String stateMachine, StateMachineConfig config) 
    	        throws EventProcessorException {
		        /* Get state machine from path */
        		int sm = decodeStateMachine(stateMachine);
        		int state;
		        		switch (sm) {
					            case liftAutomat:
                				state = _liftAutomat.decodeState(config.getActiveState());
				                switch (state) {
																																																																																											                    case liftAutomatEventProcessor.FinalState:
																											                        return true;
				                    					default:
                    						    return false;
                	}
					            default:
                				throw new EventProcessorException("Unknown state machine [" + stateMachine + "]");
		        }
	    }			
}
	
			







private class liftAutomatEventProcessor {

		// states
	    private static final int Top = 1;
	    private static final int ___ = 2;
	    private static final int _ = 3;
	    private static final int __1 = 4;
	    private static final int _ = 5;
	    private static final int InitialState = 6;
	    private static final int _ = 7;
	    private static final int __2 = 8;
	    private static final int FinalState = 9;
	    private static final int ___ = 10;
	
	private int decodeState(String state) {
					
		if ("Top".equals(state)) {
			return Top;
						} else 
				
		if ("   ".equals(state)) {
			return ___;
						} else 
				
		if (" ".equals(state)) {
			return _;
						} else 
				
		if ("  1".equals(state)) {
			return __1;
						} else 
				
		if (" ".equals(state)) {
			return _;
						} else 
				
		if ("InitialState".equals(state)) {
			return InitialState;
						} else 
				
		if (" ".equals(state)) {
			return _;
						} else 
				
		if ("  2".equals(state)) {
			return __2;
						} else 
				
		if ("FinalState".equals(state)) {
			return FinalState;
						} else 
				
		if ("   ".equals(state)) {
			return ___;
			}
		
		return -1;
	}
	
		// events
	    private static final int HasBroken = 1;
	    private static final int Exit = 2;
	    private static final int HasBeenRepaired = 3;
	    private static final int OpenTheDoors = 4;
	    private static final int GoDown = 5;
	    private static final int GoUp = 6;
	    private static final int NewTaskAdded = 7;
	    private static final int QueueIsEmpty = 8;
	    private static final int CloseTheDoors = 9;
	
	private int decodeEvent(String event) {
					
		if ("HasBroken".equals(event)) {
			return HasBroken;
						} else 
				
		if ("Exit".equals(event)) {
			return Exit;
						} else 
				
		if ("HasBeenRepaired".equals(event)) {
			return HasBeenRepaired;
						} else 
				
		if ("OpenTheDoors".equals(event)) {
			return OpenTheDoors;
						} else 
				
		if ("GoDown".equals(event)) {
			return GoDown;
						} else 
				
		if ("GoUp".equals(event)) {
			return GoUp;
						} else 
				
		if ("NewTaskAdded".equals(event)) {
			return NewTaskAdded;
						} else 
				
		if ("QueueIsEmpty".equals(event)) {
			return QueueIsEmpty;
						} else 
				
		if ("CloseTheDoors".equals(event)) {
			return CloseTheDoors;
				}
	
		return -1;
	}
		
							private ru.ifmo.lift.MainForm oForm;
								private ru.ifmo.lift.Lift oLift;
				
	private void init(ControlledObjectsMap controlledObjectsMap) {
									oForm = (ru.ifmo.lift.MainForm)controlledObjectsMap.getControlledObject("oForm");
												oLift = (ru.ifmo.lift.Lift)controlledObjectsMap.getControlledObject("oLift");
						}
		
	private StateMachineConfig process(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
		config = lookForTransition(event, context, path, config);
		
		config = transiteToStableState(context, path, config);
		
		// execute included state machines
		executeSubmachines(event, context, path, config);
		
		return config;
	}
	
	private void executeSubmachines(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
		int state = decodeState(config.getActiveState());
		
		while (true) {
		switch (state) {
																			case ___: 
					
											return;
																					case _: 
					
											return;
																					case __1: 
					
											return;
																					case _: 
					
											return;
																					case InitialState: 
					
											return;
																					case _: 
					
											return;
																					case __2: 
					
											return;
																					case FinalState: 
					
											return;
																					case ___: 
					
											return;
																default:
					throw new EventProcessorException("State with name [" + config.getActiveState() + "] is unknown for state machine [liftAutomat]");
		}
		}
	}
	
	private StateMachineConfig transiteToStableState(StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {

		int s = decodeState(config.getActiveState());
		Event event;

		switch (s) {
									case Top:
					
										
					fireComeToState(context, path, "InitialState");

					// InitialState->  [true]/
					event = Event.NO_EVENT;
						fireTransitionFound(context, path, "InitialState", event, "InitialState# ##true");
	
		
	fireComeToState(context, path, " ");
	
	//   [oLift.chooseDirection]
				fireBeforeOutputActionExecution(context, path, "InitialState# ##true", "oLift.chooseDirection");

				oLift.chooseDirection(context);
		
	fireAfterOutputActionExecution(context, path, "InitialState# ##true", "oLift.chooseDirection");
						
											return new StateMachineConfig(" ");
																																																									}
	
		return config;
	}    
	
	private StateMachineConfig lookForTransition(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
					
		
				
		
	
				BitSet calculatedInputActions = new BitSet(0);
		
		int s = decodeState(config.getActiveState());
		int e = decodeEvent(event.getName());
	
		while (true) {
			switch (s) {
																			case ___:
						
											
												switch (e) {
													case HasBeenRepaired:
																
						//    ->  HasBeenRepaired[true]/
			
			fireTransitionCandidate(context, path, "   ", event, "   # #HasBeenRepaired#true");
			
						
							
			
							
					fireTransitionFound(context, path, "   ", event, "   # #HasBeenRepaired#true");
	
		
	fireComeToState(context, path, " ");
	
	//   [oLift.goUp]
				fireBeforeOutputActionExecution(context, path, "   # #HasBeenRepaired#true", "oLift.goUp");

				oLift.goUp(context);
		
	fireAfterOutputActionExecution(context, path, "   # #HasBeenRepaired#true", "oLift.goUp");
					return new StateMachineConfig(" ");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case _:
						
											
												switch (e) {
													case HasBroken:
																
						//  ->    HasBroken[true]/
			
			fireTransitionCandidate(context, path, " ", event, " #   #HasBroken#true");
			
						
							
			
							
					fireTransitionFound(context, path, " ", event, " #   #HasBroken#true");
	
		
	fireComeToState(context, path, "   ");
	
	//     [oForm.showBreakageMsg]
				fireBeforeOutputActionExecution(context, path, " #   #HasBroken#true", "oForm.showBreakageMsg");

				oForm.showBreakageMsg(context);
		
	fireAfterOutputActionExecution(context, path, " #   #HasBroken#true", "oForm.showBreakageMsg");
					return new StateMachineConfig("   ");

																				
														case OpenTheDoors:
																
						//  ->  1 OpenTheDoors[true]/oForm.updateButtons,oLift.openTheDoors
			
			fireTransitionCandidate(context, path, " ", event, " #  1#OpenTheDoors#true");
			
						
							
			
							
					fireTransitionFound(context, path, " ", event, " #  1#OpenTheDoors#true");
	
				fireBeforeOutputActionExecution(context, path, " #  1#OpenTheDoors#true", "oForm.updateButtons");

				oForm.updateButtons(context);
		
	fireAfterOutputActionExecution(context, path, " #  1#OpenTheDoors#true", "oForm.updateButtons");
				fireBeforeOutputActionExecution(context, path, " #  1#OpenTheDoors#true", "oLift.openTheDoors");

				oLift.openTheDoors(context);
		
	fireAfterOutputActionExecution(context, path, " #  1#OpenTheDoors#true", "oLift.openTheDoors");
		
	fireComeToState(context, path, "  1");
	
	//   1 [oLift.waitOpened]
				fireBeforeOutputActionExecution(context, path, " #  1#OpenTheDoors#true", "oLift.waitOpened");

				oLift.waitOpened(context);
		
	fireAfterOutputActionExecution(context, path, " #  1#OpenTheDoors#true", "oLift.waitOpened");
					return new StateMachineConfig("  1");

																				
														case QueueIsEmpty:
																
						//  ->  QueueIsEmpty[true]/oLift.changeDirection
			
			fireTransitionCandidate(context, path, " ", event, " # #QueueIsEmpty#true");
			
						
							
			
							
					fireTransitionFound(context, path, " ", event, " # #QueueIsEmpty#true");
	
				fireBeforeOutputActionExecution(context, path, " # #QueueIsEmpty#true", "oLift.changeDirection");

				oLift.changeDirection(context);
		
	fireAfterOutputActionExecution(context, path, " # #QueueIsEmpty#true", "oLift.changeDirection");
		
	fireComeToState(context, path, " ");
	
	//   [oLift.chooseDirection]
				fireBeforeOutputActionExecution(context, path, " # #QueueIsEmpty#true", "oLift.chooseDirection");

				oLift.chooseDirection(context);
		
	fireAfterOutputActionExecution(context, path, " # #QueueIsEmpty#true", "oLift.chooseDirection");
					return new StateMachineConfig(" ");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case __1:
						
											
												switch (e) {
													case CloseTheDoors:
																
						//   1->  CloseTheDoors[true]/oLift.closeTheDoors
			
			fireTransitionCandidate(context, path, "  1", event, "  1# #CloseTheDoors#true");
			
						
							
			
							
					fireTransitionFound(context, path, "  1", event, "  1# #CloseTheDoors#true");
	
				fireBeforeOutputActionExecution(context, path, "  1# #CloseTheDoors#true", "oLift.closeTheDoors");

				oLift.closeTheDoors(context);
		
	fireAfterOutputActionExecution(context, path, "  1# #CloseTheDoors#true", "oLift.closeTheDoors");
		
	fireComeToState(context, path, " ");
	
	//   [oLift.goUp]
				fireBeforeOutputActionExecution(context, path, "  1# #CloseTheDoors#true", "oLift.goUp");

				oLift.goUp(context);
		
	fireAfterOutputActionExecution(context, path, "  1# #CloseTheDoors#true", "oLift.goUp");
					return new StateMachineConfig(" ");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case _:
						
											
												switch (e) {
													case Exit:
																
						//  ->FinalState Exit[true]/oForm.closeForm
			
			fireTransitionCandidate(context, path, " ", event, " #FinalState#Exit#true");
			
						
							
			
							
					fireTransitionFound(context, path, " ", event, " #FinalState#Exit#true");
	
				fireBeforeOutputActionExecution(context, path, " #FinalState#Exit#true", "oForm.closeForm");

				oForm.closeForm(context);
		
	fireAfterOutputActionExecution(context, path, " #FinalState#Exit#true", "oForm.closeForm");
		
	fireComeToState(context, path, "FinalState");
	
	// FinalState []
					return new StateMachineConfig("FinalState");

																				
														case GoDown:
																
						//  ->  GoDown[true]/
			
			fireTransitionCandidate(context, path, " ", event, " # #GoDown#true");
			
						
							
			
							
					fireTransitionFound(context, path, " ", event, " # #GoDown#true");
	
		
	fireComeToState(context, path, " ");
	
	//   [oLift.goDown]
				fireBeforeOutputActionExecution(context, path, " # #GoDown#true", "oLift.goDown");

				oLift.goDown(context);
		
	fireAfterOutputActionExecution(context, path, " # #GoDown#true", "oLift.goDown");
					return new StateMachineConfig(" ");

																				
														case GoUp:
																
						//  ->  GoUp[true]/
			
			fireTransitionCandidate(context, path, " ", event, " # #GoUp#true");
			
						
							
			
							
					fireTransitionFound(context, path, " ", event, " # #GoUp#true");
	
		
	fireComeToState(context, path, " ");
	
	//   [oLift.goUp]
				fireBeforeOutputActionExecution(context, path, " # #GoUp#true", "oLift.goUp");

				oLift.goUp(context);
		
	fireAfterOutputActionExecution(context, path, " # #GoUp#true", "oLift.goUp");
					return new StateMachineConfig(" ");

																				
														case NewTaskAdded:
																
						//  ->  NewTaskAdded[true]/
			
			fireTransitionCandidate(context, path, " ", event, " # #NewTaskAdded#true");
			
						
							
			
							
					fireTransitionFound(context, path, " ", event, " # #NewTaskAdded#true");
	
		
	fireComeToState(context, path, " ");
	
	//   [oLift.chooseDirection]
				fireBeforeOutputActionExecution(context, path, " # #NewTaskAdded#true", "oLift.chooseDirection");

				oLift.chooseDirection(context);
		
	fireAfterOutputActionExecution(context, path, " # #NewTaskAdded#true", "oLift.chooseDirection");
					return new StateMachineConfig(" ");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																													case _:
						
											
												switch (e) {
													case HasBroken:
																
						//  ->    HasBroken[true]/
			
			fireTransitionCandidate(context, path, " ", event, " #   #HasBroken#true");
			
						
							
			
							
					fireTransitionFound(context, path, " ", event, " #   #HasBroken#true");
	
		
	fireComeToState(context, path, "   ");
	
	//     [oForm.showBreakageMsg]
				fireBeforeOutputActionExecution(context, path, " #   #HasBroken#true", "oForm.showBreakageMsg");

				oForm.showBreakageMsg(context);
		
	fireAfterOutputActionExecution(context, path, " #   #HasBroken#true", "oForm.showBreakageMsg");
					return new StateMachineConfig("   ");

																				
														case OpenTheDoors:
																
						//  ->  2 OpenTheDoors[true]/oForm.updateButtons,oLift.openTheDoors
			
			fireTransitionCandidate(context, path, " ", event, " #  2#OpenTheDoors#true");
			
						
							
			
							
					fireTransitionFound(context, path, " ", event, " #  2#OpenTheDoors#true");
	
				fireBeforeOutputActionExecution(context, path, " #  2#OpenTheDoors#true", "oForm.updateButtons");

				oForm.updateButtons(context);
		
	fireAfterOutputActionExecution(context, path, " #  2#OpenTheDoors#true", "oForm.updateButtons");
				fireBeforeOutputActionExecution(context, path, " #  2#OpenTheDoors#true", "oLift.openTheDoors");

				oLift.openTheDoors(context);
		
	fireAfterOutputActionExecution(context, path, " #  2#OpenTheDoors#true", "oLift.openTheDoors");
		
	fireComeToState(context, path, "  2");
	
	//   2 [oLift.waitOpened]
				fireBeforeOutputActionExecution(context, path, " #  2#OpenTheDoors#true", "oLift.waitOpened");

				oLift.waitOpened(context);
		
	fireAfterOutputActionExecution(context, path, " #  2#OpenTheDoors#true", "oLift.waitOpened");
					return new StateMachineConfig("  2");

																				
														case QueueIsEmpty:
																
						//  ->  QueueIsEmpty[true]/oLift.changeDirection
			
			fireTransitionCandidate(context, path, " ", event, " # #QueueIsEmpty#true");
			
						
							
			
							
					fireTransitionFound(context, path, " ", event, " # #QueueIsEmpty#true");
	
				fireBeforeOutputActionExecution(context, path, " # #QueueIsEmpty#true", "oLift.changeDirection");

				oLift.changeDirection(context);
		
	fireAfterOutputActionExecution(context, path, " # #QueueIsEmpty#true", "oLift.changeDirection");
		
	fireComeToState(context, path, " ");
	
	//   [oLift.chooseDirection]
				fireBeforeOutputActionExecution(context, path, " # #QueueIsEmpty#true", "oLift.chooseDirection");

				oLift.chooseDirection(context);
		
	fireAfterOutputActionExecution(context, path, " # #QueueIsEmpty#true", "oLift.chooseDirection");
					return new StateMachineConfig(" ");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case __2:
						
											
												switch (e) {
													case CloseTheDoors:
																
						//   2->  CloseTheDoors[true]/oLift.closeTheDoors
			
			fireTransitionCandidate(context, path, "  2", event, "  2# #CloseTheDoors#true");
			
						
							
			
							
					fireTransitionFound(context, path, "  2", event, "  2# #CloseTheDoors#true");
	
				fireBeforeOutputActionExecution(context, path, "  2# #CloseTheDoors#true", "oLift.closeTheDoors");

				oLift.closeTheDoors(context);
		
	fireAfterOutputActionExecution(context, path, "  2# #CloseTheDoors#true", "oLift.closeTheDoors");
		
	fireComeToState(context, path, " ");
	
	//   [oLift.goDown]
				fireBeforeOutputActionExecution(context, path, "  2# #CloseTheDoors#true", "oLift.goDown");

				oLift.goDown(context);
		
	fireAfterOutputActionExecution(context, path, "  2# #CloseTheDoors#true", "oLift.goDown");
					return new StateMachineConfig(" ");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																													case ___:
						
											
												switch (e) {
													case HasBeenRepaired:
																
						//    ->  HasBeenRepaired[true]/
			
			fireTransitionCandidate(context, path, "   ", event, "   # #HasBeenRepaired#true");
			
						
							
			
							
					fireTransitionFound(context, path, "   ", event, "   # #HasBeenRepaired#true");
	
		
	fireComeToState(context, path, " ");
	
	//   [oLift.goDown]
				fireBeforeOutputActionExecution(context, path, "   # #HasBeenRepaired#true", "oLift.goDown");

				oLift.goDown(context);
		
	fireAfterOutputActionExecution(context, path, "   # #HasBeenRepaired#true", "oLift.goDown");
					return new StateMachineConfig(" ");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																	default:
					throw new EventProcessorException("Incorrect stable state [" + config.getActiveState() + "] in state machine [liftAutomat]");
			}
		}
	}

		        
}
	
	private static boolean isInputActionCalculated(BitSet calculatedInputActions, int k) {
		boolean b = calculatedInputActions.get(k);
            
        if (!b) {
			calculatedInputActions.set(k);
		}
            
        return b;
	}
	
}
	
