/**
  * This file was generated from model [Model1] on [Fri Oct 13 20:36:21 MSD 2006].
  * Do not change content of this file.
  */

#ifndef __Model1ModelEngine_H__
#define __Model1ModelEngine_H__

#include <e32def.h>
#include <f32file.h>
#include <s32file.h>

/* Forward declaration of model engine class */	
class CModel1ModelEngine;
/* Forward declaration of base state machine class */	
class CModel1BaseMachine;
/* Forward declaration of state machines from the model */	
class TLiftAutomat;

/* Include state machine context class header */	
#include "StateMachineContext.h"

/* Include used controlled objects classes headers */	
#include "ru.ifmo.lift.MainForm.h"
#include "ru.ifmo.lift.Lift.h"

/******************************************
 Model engine class: Model1
 ******************************************/
class CModel1ModelEngine
    {
		friend class TLiftAutomat;

	public:
		static CModel1ModelEngine* NewL(
            ru.ifmo.lift.MainForm* aOForm,
            ru.ifmo.lift.Lift* aOLift);

		static CModel1ModelEngine* NewLC(
            ru.ifmo.lift.MainForm* aOForm,
            ru.ifmo.lift.Lift* aOLift);
		
		virtual ~CModel1ModelEngine();

	private:

		void ConstructL(
            ru.ifmo.lift.MainForm* aOForm,
            ru.ifmo.lift.Lift* aOLift);

	public:
		enum EEvent
            {
            CLOSE_THE_DOORS,
            EXIT,
            GO_DOWN,
            GO_UP,
            HAS_BEEN_REPAIRED,
            HAS_BROKEN,
            NEW_TASK_ADDED,
            OPEN_THE_DOORS,
            QUEUE_IS_EMPTY,
            ANY_OTHER
            };
	
		void HandleL(EEvent aEvent);
		
		TStateMachineContext& Context() {return iContext;}
				
		RWriteStream* Log() {return iLog;}

		const TDesC& EventName(EEvent anEvent) const;
		
	private:
		// State machine context
		TStateMachineContext iContext;
	
	    // Statemachines are owned by CModel1ModelEngine
		TLiftAutomat* iLiftAutomat;
		
		// Logger stream isn't owned by CAutoAnswererModelEngine
		RWriteStream* iLog;
	};

/**
 * Base state machine class for model: Model1
 */
class CModel1BaseMachine
	{
	public:
		/* Constructor of base state machine */
		CModel1BaseMachine(CModel1ModelEngine& aModel): iModel(aModel) {}
				
        virtual void HandleL(CModel1ModelEngine::EEvent aEvent, TStateMachineContext& aContext) = 0;

	protected:
		CModel1ModelEngine& iModel;
		
		virtual const TDesC& MachineName() const = 0;
		
		/**
		 * Logging methods
		 */
		void DoLogL(TDesC& message);
		void LogBeginL(const TDesC& aStateName, CAutoAnswererModelEngine::EEvent aEvent);
		void LogTransiteL(const TDesC& aOldStateName, const TDesC& aNewStateName);
		void LogEndL(const TDesC& aStateName, CAutoAnswererModelEngine::EEvent aEvent);
		void LogActionBeginL(const TDesC& anIdentifier);
		void LogActionEndL(const TDesC& anIdentifier);
		void LogActionEndL(const TDesC& anIdentifier, TInt aValue);
	};

/******************************************
 State machine class: liftAutomat          
 ******************************************/
class TLiftAutomat: CModel1BaseMachine
	{
	public:
		/* Constructor of state machine liftAutomat */
		TLiftAutomat(CModel1ModelEngine& aModel): CModel1BaseMachine(aModel), iState(TOP) {}
		
        void HandleL(CModel1ModelEngine::EEvent aEvent, TStateMachineContext& aContext);
		
        /* Controlled objects setters */
		void SetOForm(ru.ifmo.lift.MainForm* aOForm) {iOForm = aOForm;}
		void SetOLift(ru.ifmo.lift.Lift* aOLift) {iOLift = aOLift;}


	private:
		enum EState 
            {
            __1,
            __2,
            TOP,
            ___,
            _,
            _,
            _,
            FINAL_STATE,
            ___,
            UNKNOWN_STATE
            };

        EState iState;

        /* Controlled objects */
		ru.ifmo.lift.MainForm* iOForm;
		ru.ifmo.lift.Lift* iOLift;


		TBool IsStable(EState aState) const;
		EState GetSuperstate(EState aState) const;
		const TDesC& StateName(EState aState) const; 
		const TDesC& MachineName() const;
		EState TransiteOnEventL(CModel1ModelEngine::EEvent aEvent, TStateMachineContext& aContext);
		EState TransiteToStableL(EState aState, TStateMachineContext& aContext);
		void EnterStateL(EState aState, TStateMachineContext& aContext);
		void InvokeSubmachinesL(CModel1ModelEngine::EEvent aEvent, TStateMachineContext& aContext);
	};

#endif // __Model1ModelEngine_H__